/*
 * NumberExp.java 1.0 2006-02-14
 *
 * Copyright (C) 2006 by Ifi, UiO
 */

import antlr.Token;

/**
 * Simple AST class for a number expression.
 *
 * @version $Revision:$
 * @author Sven-Jrgen Karlsen <svenjok@ifi.uio.no>
 * @since 1.0
 */
public final class NumberExp extends BaseASTAdapter implements Exp  {
    
    private int value;

    public NumberExp(int value) {
        super();
        this.value = value;
    }

    public NumberExp(Token token) {
        super();
        this.value = Integer.parseInt(token.getText());;
    }
    
    /** See explanation in BinaryExp. */
    public String toLispString() {
        return "(" + value + ")";
    }

    public String toString() {
        return Integer.toString(value);
    }

    // Cumbersome Antlr callback to have this class usable in a tree
    // grammar.

    /** Get the token text for this node */
    public String getText() {
        return Integer.toString(value);
    }

    /** 
     * Get the token type for this node 
     */
    public int getType() {
        return AmbigiousExpTokenTypes.NUMBER;
    }

}

/* NumberExp.java ends here */
